#include "stdafx.h"
#include "DimRadial.h"
#include <acedCmdNF.h>

CDimRadial::CDimRadial(void)
{
}


CDimRadial::~CDimRadial(void)
{
}

void CDimRadial::DrawDimRadial()
{
	ads_point adsPoint;
	ads_name adsSelEntity;
	int nRet = acedEntSel(_T("\nSelect Circle or Arc: "), adsSelEntity, adsPoint);
	if(nRet != RTNORM)
	{
		return;
	}
	AcGePoint3d ptPickPoint;
	ptPickPoint = asPnt3d(adsPoint);
	AcDbObjectId idEnt;
	Acad::ErrorStatus es = acdbGetObjectId(idEnt, adsSelEntity);
	if(es != Acad::eOk)
	{
		return;
	}
	acedSSFree(adsSelEntity);

	AcDbObjectPointer <AcDbEntity> pEntity(idEnt, AcDb::kForRead);
	if(pEntity.openStatus()!=Acad::eOk)
	{
		return;
	}
	//Process on Arc entity
	if( pEntity->isKindOf(AcDbArc::desc()))
	{
		AcDbArc* pArc = AcDbArc::cast(pEntity);
		if(pArc == NULL)
		{
			return;
		}
		double dRadius, dStartAngle, dEndAngle;
		AcGePoint3d ptCenterPoint;
		AcGeVector3d vecCircle;
		ptCenterPoint = pArc->center();
		dRadius = pArc->radius();
		dStartAngle = pArc->startAngle();
		dEndAngle = pArc->endAngle();
		vecCircle = pArc->normal();

		//Dimension Text location point
		ads_point adsPassPoint;
		nRet = acedGetPoint(NULL, _T("\nSpecify Arc Length dimension location: "), adsPassPoint);
		if(nRet != RTNORM)
		{
			return;
		}
		AcGePoint3d ptPassPoint;
		ptPassPoint = asPnt3d(adsPassPoint);

		//To find ChordPoint of Circle
		AcGeLine3d XLine;
		XLine.set(ptCenterPoint, ptPassPoint);
		AcGeCircArc3d Circle;
		Circle.set(ptCenterPoint, vecCircle, dRadius);
		int nIntersectNum;
		AcGePoint3d ptIntPoint1, ptIntPoint2, ptChordPoint;
		Circle.intersectWith(XLine, nIntersectNum, ptIntPoint1, ptIntPoint2, AcGeContext::gTol);
		ptChordPoint = ptIntPoint1;

		//Radius Dimension
		AcDbRadialDimension* pRadius = new AcDbRadialDimension(ptCenterPoint, ptChordPoint, dRadius);
		pRadius->setTextPosition(ptPassPoint);
		AcDbObjectId idRadius;
		AppendEntity(idRadius, pRadius);
		pRadius->close();
	}
	else
	{
		acutPrintf(_T("\nObject Selected is not an Arc."));
	}
}

void CDimRadial::AppendEntity(AcDbObjectId &idDim, AcDbEntity *pEntity)
{
	AcDbDatabase* pEntityDataBase = acdbHostApplicationServices()->workingDatabase();
	Acad::ErrorStatus esStatusEntity;
	AcDbBlockTable* pEntityTable = NULL;
	esStatusEntity = pEntityDataBase->getBlockTable(pEntityTable, AcDb::kForRead);
	if (esStatusEntity != Acad::eOk)
	{
		return;
	}
	AcDbBlockTableRecord* pEntityTableRecord = NULL;
	esStatusEntity = pEntityTable->getAt(ACDB_MODEL_SPACE, pEntityTableRecord, AcDb::kForWrite);
	if (esStatusEntity != eOk)
	{
		pEntityTable->close();
		return;
	}
	esStatusEntity = pEntityTableRecord->appendAcDbEntity(idDim, pEntity);
	if (esStatusEntity != eOk)
	{
		pEntityTableRecord->close();
		pEntityTable->close();
		return;
	}
	pEntityTableRecord->close();
	pEntityTable->close();
}